﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;
using System.Timers;
using System.Threading.Tasks;

namespace U3751com
{
    public partial class Form1 : Form
    {
        // グローバル変数宣言
        private int flg_lan;
        private String filePath { get; set; }
        StringBuilder U3751_IP = new StringBuilder(1024);
        int flg_thread = 1;

        // スペアナパラメータ
        public string st_cf;
        public string st_sp;
        public string st_dd;
        public string st_rl;
        public double db_cf;
        public double db_sp;
        public double db_delta;
        public double db_offset;

        //NetworkStreamを取得する
        System.Net.Sockets.NetworkStream ns;
        System.Net.Sockets.TcpClient tcp;
        System.IO.MemoryStream ms;

        // ログ
        string file;
        String logPath;
        System.IO.StreamWriter log;
        string dat;
        int i_inter;
        int i_inter_graph;

        //System.Timers.Timer timer;
        Thread thread;
        long prevtime;

        // iniファイル機能ロード
        [DllImport("KERNEL32.DLL")]
        public static extern uint
        GetPrivateProfileString(string lpAppName,
        string lpKeyName, string lpDefault,
        StringBuilder lpReturnedString, uint nSize,
        string lpFileName);

        [DllImport("KERNEL32.DLL",
        EntryPoint = "GetPrivateProfileStringA")]
        public static extern uint
        GetPrivateProfileStringByByteArray(string lpAppName,
        string lpKeyName, string lpDefault,
        byte[] lpReturnedString, uint nSize,
        string lpFileName);

        [DllImport("KERNEL32.DLL")]
        public static extern uint
        GetPrivateProfileInt(string lpAppName,
        string lpKeyName, int nDefault, string lpFileName);

        [DllImport("KERNEL32.DLL")]
        public static extern uint WritePrivateProfileString(
        string lpAppName,
        string lpKeyName,
        string lpString,
        string lpFileName);

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // 起動時の処理
            // ini読み出し
            this.filePath = AppDomain.CurrentDomain.BaseDirectory + "U3751com.ini";

            // IPアドレス読み出し
            Form1.GetPrivateProfileString("LAN", "U3751_IP", "192.168.0.10", U3751_IP, (uint)U3751_IP.Capacity, filePath);
            //Form1.WritePrivateProfileString("LAN", "U3751_IP", "192.168.0.10", filePath);

            // toolstrip表示
            toolStripStatusLabel1.Text = "未接続";

            // タイマーのインターバルを設定
            // http://devlights.hatenablog.com/entry/20100524/p1
            //timer = new System.Timers.Timer();
            //timer.Elapsed += OnTimerElapsed;
            //timer.Interval = (int)Form1.GetPrivateProfileInt("TIMER", "Interval", 100, filePath);
            //timer.SynchronizingObject = this;
            i_inter = (int)Form1.GetPrivateProfileInt("TIMER", "Interval", 100, filePath);
            prevtime = DateTime.Now.ToUniversalTime().Ticks;
            
            // http://www.atmarkit.co.jp/ait/articles/0504/20/news111_2.html
            thread = new Thread(new ThreadStart(ThreadMethod));

            // フラグ初期化
            flg_lan = 0;

            // グラフ初期化
            i_inter_graph = (int)Form1.GetPrivateProfileInt("TIMER", "Graph", 500, filePath);
            timer1.Interval = i_inter_graph;

            chart1.Series.Clear();
            chart1.Series.Add("PLL");
            chart1.Series["PLL"].ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Line;
            //chart1.ChartAreas[0].AxisX.Minimum = 0;
            chart1.ChartAreas[0].AxisY.Title = "レベル[a.u.]";
            chart1.ChartAreas[0].AxisX.Title = "周波数[MHz]";

            chart1.ChartAreas[0].AxisY.Minimum = 0;
            chart1.ChartAreas[0].AxisY.Maximum = 15000;

            // 凡例なし
            chart1.Legends.Clear();
        }

        private void 接続CToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // LAN接続
            // http://dobon.net/vb/dotnet/internet/tcpclientserver.html
            string ipOrHost = U3751_IP.ToString();

            // Listenするポート番号
            int port = 5025;

            if (flg_lan == 0)
            {
                //TcpClientを作成し、サーバーと接続する
                tcp = new System.Net.Sockets.TcpClient(ipOrHost, port);
                Console.WriteLine("サーバー({0}:{1})と接続しました({2}:{3})。",
                    ((System.Net.IPEndPoint)tcp.Client.RemoteEndPoint).Address,
                    ((System.Net.IPEndPoint)tcp.Client.RemoteEndPoint).Port,
                    ((System.Net.IPEndPoint)tcp.Client.LocalEndPoint).Address,
                    ((System.Net.IPEndPoint)tcp.Client.LocalEndPoint).Port);

                //NetworkStreamを取得する
                ns = tcp.GetStream();

                //読み取り、書き込みのタイムアウトを10秒にする
                //デフォルトはInfiniteで、タイムアウトしない
                //(.NET Framework 2.0以上が必要)
                ns.ReadTimeout = 10000;
                ns.WriteTimeout = 10000;

                // 接続開始 初期化
                cmd_polling("REN");
                cmd_only("DLIM1");
                //cmd_only("*CLS");
                //cmd_only("*RST");
                st_cf = cmd_polling("CF?");
                st_sp = cmd_polling("SP?");
                st_dd = cmd_polling("DD?");
                st_rl = cmd_polling("RL?");
                db_cf = double.Parse(st_cf);
                db_sp = double.Parse(st_sp);
                db_delta = db_sp / 1000;
                db_offset = db_cf - (db_sp / 2);
                Console.Write(db_delta.ToString());

                // ログ保存
                file = System.DateTime.Now.ToString();
                file = file.Replace("/", "");
                file = file.Replace(":", "");
                file = file.Replace(" ", "");
                logPath = AppDomain.CurrentDomain.BaseDirectory + "Log_U3751_" + file + ".csv";
                log = new System.IO.StreamWriter(logPath, true, System.Text.Encoding.GetEncoding("shift_jis"));
                
                // ヘッダ出力
                log.WriteLine("# 中心周波数," + st_cf);
                log.WriteLine("# SPAN," + st_cf);
                log.WriteLine("# XdB/Div," + st_dd);
                log.WriteLine("# RefLev," + st_rl);

                log.Write("# Time/Freq,");
                for (int i = 0; i <= 1001; i++)
                {
                    log.Write(i*db_delta+db_offset);
                    log.Write(",");
                }
                log.Write("\n");

                // timer開始
                thread.Start();
                System.Threading.Thread.Sleep(i_inter);
                timer1.Start();
                //timer.Enabled = true;

                // toolstrip表示
                toolStripStatusLabel1.Text = "接続中";

                // フラグ更新
                flg_lan = 1;
            }
        }

        // 送りっぱなしコマンド
        private void cmd_only(string cmd)
        {
            // コマンド設定
            System.Text.Encoding enc = System.Text.Encoding.UTF8;
            byte[] sendBytes = enc.GetBytes(cmd + '\n');
            ns.Write(sendBytes, 0, sendBytes.Length);
        }

        // スペアナ値取得
        private string cmd_taa()
        {
            // コマンド設定
            System.Text.Encoding enc = System.Text.Encoding.UTF8;
            byte[] sendBytes = enc.GetBytes("TAA?" + '\n');
            ns.Write(sendBytes, 0, sendBytes.Length);

            // サーバーから送られたデータを受信する
            ms = new System.IO.MemoryStream();
            byte[] resBytes = new byte[6006+10];
            int resSize = 0;

             do
            {
                // データの一部を受信する
                resSize = ns.Read(resBytes, 0, resBytes.Length);
                // Readが0を返した時はサーバーが切断したと判断
                if (resSize == 0)
                {
                    Console.WriteLine("サーバーが切断しました。");
                    break;
                }

                // 受信したデータを蓄積する
                ms.Write(resBytes, 0, resSize);
                // まだ読み取れるデータがあるか、データの最後が\nでない時は、
                // 受信を続ける
                //Console.WriteLine(resSize.ToString());
                //ns.DataAvailable || resBytes[resSize - 1] != '\n'
            } while (resSize < 6006);

            string resMsg = enc.GetString(ms.GetBuffer(), 0, (int)ms.Length);
            ms.Close();

            // 末尾の\nを削除
            resMsg = resMsg.Replace('\n', ',');
            resMsg = resMsg + '\n';
            //Console.WriteLine(resMsg);

            return resMsg;
        }

        // ポーリングコマンド送信
        private string cmd_polling(string cmd)
        {
            // コマンド設定
            System.Text.Encoding enc = System.Text.Encoding.UTF8;
            byte[] sendBytes = enc.GetBytes(cmd + '\n');
            ns.Write(sendBytes, 0, sendBytes.Length);

            // サーバーから送られたデータを受信する
            ms = new System.IO.MemoryStream();
            byte[] resBytes = new byte[256];
            int resSize = 0;

            do
            {
                // データの一部を受信する
                resSize = ns.Read(resBytes, 0, resBytes.Length);
                // Readが0を返した時はサーバーが切断したと判断
                if (resSize == 0)
                {
                    Console.WriteLine("サーバーが切断しました。");
                    break;
                }

                // 受信したデータを蓄積する
                ms.Write(resBytes, 0, resSize);
                // まだ読み取れるデータがあるか、データの最後が\nでない時は、
                // 受信を続ける

           
            } while (ns.DataAvailable || resBytes[resSize - 1] != '\n');

            // 受信したデータを文字列に変換
            string resMsg = enc.GetString(ms.GetBuffer(), 0, (int)ms.Length);
            ms.Close();

            // 末尾の\nを削除
            resMsg = resMsg.TrimEnd('\n');
            Console.WriteLine(resMsg);

            return resMsg;
        }

        //void OnTimerElapsed(object sender, System.Timers.ElapsedEventArgs e)
        //{
        //    string str;
        //    string times;

        //    // 定常処理
        //    str = cmd_taa();

        //    times = System.DateTime.Now.ToString() + "." + System.DateTime.Now.Millisecond.ToString();
        //    log.Write(times + "," + str);

        //    // グラフ描画
        //    stArrayData = str.Split(',');
        //    chart1.Series["PLL"].Points.Clear();

        //    for (int i = 0; i <= 1001; i++)
        //    {
        //        //stArrayData[i] = stArrayData[i].TrimEnd('\n');

        //        chart1.Series["PLL"].Points.AddXY(((i + 1) * db_delta + db_offset) / 1000000, stArrayData[i]);
        //    }
        //}

        // 別スレッドで動作させるメソッド
        private void ThreadMethod()
        {
            string str;
            string times;
            long nowtime;
            long diff;

            do
            {
                nowtime = DateTime.Now.ToUniversalTime().Ticks;
                diff = (nowtime - prevtime)/10000;

                // Wait処理
                if (diff >= i_inter)
                {
                    // 時刻取得
                    times = System.DateTime.Now.ToString() + "." + System.DateTime.Now.Millisecond.ToString();

                    // 定常処理
                    str = cmd_taa();
                    log.Write(times + "," + str);

                    // 代入
                    dat = str;

                    // 更新処理
                    prevtime = nowtime;
                }
                //else
                //{
                //    // ちょい待ち
                //    System.Threading.Thread.Sleep(1);
                //}

            } while (flg_thread == 1);
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            // グラフ描画
            if (dat != null)
            {
                string[] stArrayData = dat.Split(',');
                chart1.Series["PLL"].Points.Clear();

                for (int i = 0; i < 1001; i++)
                {
                    //stArrayData[i] = stArrayData[i].TrimEnd('\n');

                    chart1.Series["PLL"].Points.AddXY(((i + 1) * db_delta + db_offset) / 1000000, stArrayData[i]);
                }
            }
        }

        private void 終了QToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // 終了
            Close();
        }

        private void 切断UToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // 切断処理
            if (flg_lan == 1)
            {
                // timer停止
                timer1.Stop();
                //timer.Enabled = false;
                flg_thread = 0;
                System.Threading.Thread.Sleep(500);
               
                // スペアナをローカルに戻す
                //cmd_only("GTL");

                // 閉じる
                ns.Close();
                tcp.Close();
                log.Close();

                // toolstrip表示
                toolStripStatusLabel1.Text = "未接続";

                // フラグ更新
                flg_lan = 0;
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            // 終了処理
            if (flg_lan == 1)
            {
                // timer停止
                timer1.Stop();
                //timer.Enabled = false;
                //timer.Dispose();
                flg_thread = 0;
                System.Threading.Thread.Sleep(500);
               
                // 閉じる
                ns.Close();
                tcp.Close();
                log.Close();

                // フラグ更新
                flg_lan = 0;
            }
        }

        private void chart1_Click(object sender, EventArgs e)
        {
            // 何もしない
        }
        
    }
}
